addpath('argmaxmin/')
addpath('ICVM_code/')
addpath('qpc/')
addpath(genpath('checkers/'))

% C parameter of CVM
C         = 1;
iFolds    = 5; % crossvalidation number of folds

if(0)
    % read ball dataset from Pekalska / Duin
    D         = dlmread('balls_kernel.csv');
    L         = D(:,end);      % label
    K         = D(:,2:end-1);  % kernel
else         
    C = 10;
    [D,L] = gdataset('checkers',10000,0,0);
    D = D';
    mD = bsxfun(@rdivide,bsxfun(@minus,D,mean(D)),std(D));
    K = @(X,Y)tanh(1*(mD(X,:)*mD(Y,:)')+1);    
    N = numel(L);    
end

N        = numel(L);
NClasses = numel(unique(L));

% some anonymous functions to simplify crossvalidation / evaluation
global allModels;
allModels = [];
fKeepModelsGlobalPtr = @(x)fKeepModelsGlobal(x);

% icvm multiclass model function ptr
fICVMTrain           = @(X,Y)icvm_multiclass_model(X,Y,C);

% pointer for the crossvalidation function in matlab
% with an Evaluation function wrapped in
regf                 = @(XTRAIN,ytrain,XTEST,YTEST){EvaluateResults(icvm_classify(K,fKeepModelsGlobal(meb_train_cvm(fICVMTrain,K,XTRAIN,ytrain)),XTEST),YTEST)};                

% run the crossvalidation using regs 
cvRes                = crossval(regf,[[1:N]'],L,'kfold',iFolds);

% summaries results from cvRes
LSfull               = [100*(arrayfun(@(x)cvRes{x}.dAcc,[1:iFolds]))'; 100*std(arrayfun(@(x)cvRes{x}.dAcc,[1:iFolds])); 100*mean(arrayfun(@(x)cvRes{x}.dAcc,[1:iFolds]))];


